declare default element namespace 'http://пф.рф/МЗРК/2019-05-15';
declare namespace МСК4 = "http://пф.рф/ВВ/МСК/2020-07-25";
declare namespace УТ = "http://пф.рф/УТ/2017-08-21";
declare namespace МСКР5 = "http://пф.рф/ВВ/МСКР/типы/2019-05-15";
declare variable $document as document-node() external;
declare variable $root := $document/ЭДПФР;
declare function local:nodeIndex($nodes as node()*, $nodeToFind as node()) as xs:integer
{
for $seq in (1 to count($nodes))
				return $seq[$nodes[$seq] is $nodeToFind]
};
declare function local:nodePosition($node as node()?) as node()
{

				element {xs:QName("Результат")}
				{
					(:string-join(
							for $ancestor in $node/ancestor-or-self::*
							let $sibsOfSameName := $ancestor/preceding-sibling::*[name()=name($ancestor)]
							let $followingSibling := $ancestor/following-sibling::*[name()=name($ancestor)]
							return concat(name($ancestor),
								if (count($sibsOfSameName) = 0 and count($followingSibling) = 0) then '' else concat('[',count($sibsOfSameName) + 1,']')),
								'/'
						):)
					let $prefixes := ()
					let $prefixes := for $s in in-scope-prefixes($root) return insert-before($prefixes, 1, $s)
					let $ns := ()
					let $ns := for $p in $prefixes return insert-before($ns, 1, concat('Q{', namespace-uri-for-prefix($p, $root), '}'))
					return local:replacePathWithPrefixes(path($node), $ns, $prefixes)
				}
			
};
declare function local:result($path as xs:string, $expected as xs:anyAtomicType, $objectName as xs:string, $objectValue as xs:anyAtomicType) as node()
{

				if ($path = '0') then
					element {xs:QName("Результат")}
					{
						$path
					}
				else
					element {xs:QName("Результат")}
					{
						element {xs:QName("ПутьДоЭлемента")}
						{
							$path
						},
						element {xs:QName("ОжидаемоеЗначение")}
						{
							$expected
						},
						element {xs:QName("Объект")}
						{
							element {xs:QName("Наименование")}
							{
								$objectName
							},
							element {xs:QName("Значение")}
							{
								$objectValue
							}
						}
					}
			
};
declare function local:all-whitespace($arg as xs:string?) as xs:boolean
{
normalize-space($arg) = ''
};
declare function local:isEmpty($element) as xs:boolean
{
local:all-whitespace(string($element))
};
declare function local:notExistsOrEmpty($element) as xs:boolean
{
not(exists($element)) or local:isEmpty($element)
};
declare function local:getFIO($fio) as xs:string
{

				concat($fio/УТ:Фамилия, ' ', $fio/УТ:Имя, if (local:isEmpty($fio/УТ:Отчество)) then '' else concat(' ', $fio/УТ:Отчество))
			
};
declare function local:replacePathWithPrefixes($path as xs:string?, $namespaces as xs:string*, $prefixes as xs:string*) as xs:string?
{

				if (count($namespaces) > 0)
				   then local:replacePathWithPrefixes(
				   		replace($path, local:escape-for-regex($namespaces[1]), if (local:all-whitespace($prefixes[1])) then '' else concat($prefixes[1], ':')),
				          $namespaces[position() > 1],
				          $prefixes[position() > 1])
				   else $path
			
};
declare function local:escape-for-regex($arg as xs:string?) as xs:string
{

				replace($arg, '(\.|\[|\]|\\|\||\-|\^|\$|\?|\*|\+|\{|\}|\(|\))','\\$1')
			
};
declare function local:getResult($res as item()*) as item()*
{
if (exists($res)) then $res else local:result('0','','','')
};
<БлокПроверок ID="ВСЗЛ.ФИО.1" name="Блок логических правил проверки фамилии, имени, отчества">
<Проверка ID="1">
<Описание>Должен быть указан хотя бы один из элементов 'Фамилия' или 'Имя'</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Заявитель/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (local:notExistsOrEmpty($f/УТ:Фамилия) and local:notExistsOrEmpty($f/УТ:Имя)) then
								local:result(local:nodePosition($f), '', 'ФИО',	local:getFIO($f))
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>30</КодРезультата>
</Проверка>
<Проверка ID="2">
<Описание>В элементах 'Фамилия', 'Имя', 'Отчество' знак '-' не может быть последним символом элемента</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Заявитель/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (count($f/child::*) > 0) then
								for $c in $f/child::*
									return if (ends-with($c,'-')) then
										local:result(local:nodePosition($c),'','','')
									else ()
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>40</КодРезультата>
</Проверка>
<Проверка ID="3">
<Описание>Элемент 'Отчество' должен быть заполнен</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Заявитель/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (not(local:notExistsOrEmpty($f/УТ:Отчество))) then ()
							else local:result(local:nodePosition($f),'','','')
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>20</КодРезультата>
</Проверка>
<Проверка ID="4">
<Описание>Во всех документах в элементах Фамилия, Имя, Отчество допустимы следующие символы и их сочетания: буквы русского алфавита, в том числе буква Ё, буквы латинского алфавита; знаки: '-' (тире), '(апостроф), ')' (закрывающая скобка), '(' (открывающая скобка), '.' (точка), ',' (запятая)</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Заявитель/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (count($f/child::*) > 0) then
								for $c in $f/child::*
									return if (matches($c, "^[А-Яа-яЁё.,A-Za-z \-'\(\)]*$")) then ()
									else local:result(local:nodePosition($c),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>40</КодРезультата>
</Проверка>
<Проверка ID="5">
<Описание>Во всех документах в элементах Фамилия, Имя, Отчество латинские буквы допускаются</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Заявитель/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (count($f/child::*) > 0) then
								for $c in $f/child::*
									return if (not(local:isEmpty($c)) and matches($c, "[a-zA-Z]+")) then local:result(local:nodePosition($c),'','','')
									else ()
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>10</КодРезультата>
</Проверка>
<Проверка ID="6">
<Описание>Во всех документах в элементах Фамилия, Имя, Отчество знаки '–' не могут идти подряд или через пробел</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Заявитель/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (count($f/child::*) > 0) then
								for $c in $f/child::*
									return if (contains($c, '--') or contains($c, '- -')) then local:result(local:nodePosition($c),'','','')
									else ()
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>30</КодРезультата>
</Проверка>
<Проверка ID="7">
<Описание>Во всех документах в элементах Фамилия, Имя, Отчество: не допускается смешение в этих элементах букв русского и латинского алфавитов</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Заявитель/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (count($f/child::*) > 0) then
								for $c in $f/child::*									
									return if (not(matches($c, "[a-zA-Z]+") and matches($c, "[А-Яа-яЁё]+"))) then ()
									else local:result(local:nodePosition($c),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>20</КодРезультата>
</Проверка>
<Проверка ID="8">
<Описание>В элементе 'Фамилия' точка '.' и запятая ',' не допускается</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Заявитель/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (contains($f/УТ:Фамилия, '.') or contains($f/УТ:Фамилия, ',')) then local:result(local:nodePosition($f/УТ:Фамилия),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>20</КодРезультата>
</Проверка>
<Проверка ID="9">
<Описание>В элементах 'Имя' и 'Отчество' точка '.' и запятая ',' допускается</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Заявитель/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (not(contains($f/УТ:Имя, '.')) and (local:notExistsOrEmpty($f/УТ:Отчество) or not(contains($f/УТ:Отчество, '.')))) then 
									if (not(contains($f/УТ:Имя, ',')) and (local:notExistsOrEmpty($f/УТ:Отчество) or not(contains($f/УТ:Отчество, ',')))) then ()
									else local:result(local:nodePosition($f),'','','')
										else local:result(local:nodePosition($f),'','','')
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>20</КодРезультата>
</Проверка>
<Проверка ID="10">
<Описание>Во всех документах в элементах Фамилия, Имя, Отчество, знак " ' " допускается</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Заявитель/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (count($f/child::*) > 0) then
								for $c in $f/child::*
									return if (contains($c, "'")) then local:result(local:nodePosition($c),'','','')
									else ()
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>20</КодРезультата>
</Проверка>
<Проверка ID="11">
<Описание>В элементе Фамилия допускается открывающая и закрывающая скобки в следующей последовательности символов: фамилия1 один пробел (фамилия2)</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Заявитель/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (not(local:notExistsOrEmpty($f/УТ:Фамилия)) and (contains($f/УТ:Фамилия, '(') or contains($f/УТ:Фамилия, ')'))) then
								if (matches($f/УТ:Фамилия, "^([а-яА-ЯёЁ\-']+)(\s)(\([а-яА-ЯёЁ\-']+\))$")) then ()
								else local:result(local:nodePosition($f/УТ:Фамилия),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>20</КодРезультата>
</Проверка>
<Проверка ID="1">
<Описание>Должен быть указан хотя бы один из элементов 'Фамилия' или 'Имя'</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Представитель/УТ:АнкетныеДанные/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (local:notExistsOrEmpty($f/УТ:Фамилия) and local:notExistsOrEmpty($f/УТ:Имя)) then
								local:result(local:nodePosition($f), '', 'ФИО',	local:getFIO($f))
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>30</КодРезультата>
</Проверка>
<Проверка ID="2">
<Описание>В элементах 'Фамилия', 'Имя', 'Отчество' знак '-' не может быть последним символом элемента</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Представитель/УТ:АнкетныеДанные/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (count($f/child::*) > 0) then
								for $c in $f/child::*
									return if (ends-with($c,'-')) then
										local:result(local:nodePosition($c),'','','')
									else ()
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>40</КодРезультата>
</Проверка>
<Проверка ID="3">
<Описание>Элемент 'Отчество' должен быть заполнен</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Представитель/УТ:АнкетныеДанные/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (not(local:notExistsOrEmpty($f/УТ:Отчество))) then ()
							else local:result(local:nodePosition($f),'','','')
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>20</КодРезультата>
</Проверка>
<Проверка ID="4">
<Описание>Во всех документах в элементах Фамилия, Имя, Отчество допустимы следующие символы и их сочетания: буквы русского алфавита, в том числе буква Ё, буквы латинского алфавита; знаки: '-' (тире), '(апостроф), ')' (закрывающая скобка), '(' (открывающая скобка), '.' (точка), ',' (запятая)</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Представитель/УТ:АнкетныеДанные/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (count($f/child::*) > 0) then
								for $c in $f/child::*
									return if (matches($c, "^[А-Яа-яЁё.,A-Za-z \-'\(\)]*$")) then ()
									else local:result(local:nodePosition($c),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>40</КодРезультата>
</Проверка>
<Проверка ID="5">
<Описание>Во всех документах в элементах Фамилия, Имя, Отчество латинские буквы допускаются</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Представитель/УТ:АнкетныеДанные/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (count($f/child::*) > 0) then
								for $c in $f/child::*
									return if (not(local:isEmpty($c)) and matches($c, "[a-zA-Z]+")) then local:result(local:nodePosition($c),'','','')
									else ()
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>10</КодРезультата>
</Проверка>
<Проверка ID="6">
<Описание>Во всех документах в элементах Фамилия, Имя, Отчество знаки '–' не могут идти подряд или через пробел</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Представитель/УТ:АнкетныеДанные/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (count($f/child::*) > 0) then
								for $c in $f/child::*
									return if (contains($c, '--') or contains($c, '- -')) then local:result(local:nodePosition($c),'','','')
									else ()
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>30</КодРезультата>
</Проверка>
<Проверка ID="7">
<Описание>Во всех документах в элементах Фамилия, Имя, Отчество: не допускается смешение в этих элементах букв русского и латинского алфавитов</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Представитель/УТ:АнкетныеДанные/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (count($f/child::*) > 0) then
								for $c in $f/child::*									
									return if (not(matches($c, "[a-zA-Z]+") and matches($c, "[А-Яа-яЁё]+"))) then ()
									else local:result(local:nodePosition($c),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>20</КодРезультата>
</Проверка>
<Проверка ID="8">
<Описание>В элементе 'Фамилия' точка '.' и запятая ',' не допускается</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Представитель/УТ:АнкетныеДанные/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (contains($f/УТ:Фамилия, '.') or contains($f/УТ:Фамилия, ',')) then local:result(local:nodePosition($f/УТ:Фамилия),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>20</КодРезультата>
</Проверка>
<Проверка ID="9">
<Описание>В элементах 'Имя' и 'Отчество' точка '.' и запятая ',' допускается</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Представитель/УТ:АнкетныеДанные/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (not(contains($f/УТ:Имя, '.')) and (local:notExistsOrEmpty($f/УТ:Отчество) or not(contains($f/УТ:Отчество, '.')))) then 
									if (not(contains($f/УТ:Имя, ',')) and (local:notExistsOrEmpty($f/УТ:Отчество) or not(contains($f/УТ:Отчество, ',')))) then ()
									else local:result(local:nodePosition($f),'','','')
										else local:result(local:nodePosition($f),'','','')
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>20</КодРезультата>
</Проверка>
<Проверка ID="10">
<Описание>Во всех документах в элементах Фамилия, Имя, Отчество, знак " ' " допускается</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Представитель/УТ:АнкетныеДанные/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (count($f/child::*) > 0) then
								for $c in $f/child::*
									return if (contains($c, "'")) then local:result(local:nodePosition($c),'','','')
									else ()
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>20</КодРезультата>
</Проверка>
<Проверка ID="11">
<Описание>В элементе Фамилия допускается открывающая и закрывающая скобки в следующей последовательности символов: фамилия1 один пробел (фамилия2)</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $fio:=$declar/Представитель/УТ:АнкетныеДанные/УТ:ФИО
return local:getResult(
					if (count($fio) > 0) then
						for $f in $fio
							return if (not(local:notExistsOrEmpty($f/УТ:Фамилия)) and (contains($f/УТ:Фамилия, '(') or contains($f/УТ:Фамилия, ')'))) then
								if (matches($f/УТ:Фамилия, "^([а-яА-ЯёЁ\-']+)(\s)(\([а-яА-ЯёЁ\-']+\))$")) then ()
								else local:result(local:nodePosition($f/УТ:Фамилия),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>20</КодРезультата>
</Проверка>
</БлокПроверок>

